<script>
	import Button from "@/components/button.svelte"
	import SVG from "@/components/svg.svelte"
	import Tag from "@/components/Filter/Tag.svelte"

	import { brands as brandsStore, types as typesStore, isLight } from "@/stores/static"
	import { writable } from "svelte/store"
	import { goto } from "$app/navigation"
	import { active } from "@/stores/filter"
	import { t, l } from "@/i18n"
	import { page } from "$app/stores"
	import { afterUpdate, onMount } from "svelte"
	import { isPhone, isTablet } from "@/stores/responsiveness"

	const tags = writable([])

	$: largest_price = Math.max(...$page.data.cars.map(({ price }) => price.usd))
	$: hasFilter = (() => {
		const hasTypes = $page.url.searchParams.has("types")
		const hasBrands = $page.url.searchParams.has("brands")
		const hasPrice = $page.url.searchParams.has("price_min") || $page.url.searchParams.has("price_max")

		return hasTypes || hasBrands || hasPrice || $page.params.slug
	})();

	const clearFilter = () => goto($l("cars"), { noScroll: true })

	const setTags = () => {
		const result = []

		const slug = $page.params.slug
		const types = $page.url.searchParams.get("types")?.split(",")
		const brands = $page.url.searchParams.get("brands")?.split(",")
		const price_min = $page.url.searchParams.get("price_min")
		const price_max = $page.url.searchParams.get("price_max")

		if (slug) {
			const isBrand = $brandsStore.find(({ url }) => url === slug)
			const isType = $typesStore.find(({ url }) => url === slug)

			if (isBrand) result.push(isBrand)
			if (isType) result.push(isType)
		} else {
			if (types) {
				result.push(
					...types.map(type => $typesStore.find(({ url }) => url === type))
				)
			}

			if (brands) {
				result.push(
					...brands.map(brand => $brandsStore.find(({ url }) => url === brand))
				)
			}
		}

		if (price_max || price_min)
			result.push({ name: "default.tags.price", i18n: true, url: `${price_min || 0}-${price_max || largest_price}` })

		tags.set(result)
	}

	const removeValue = val => {
		const { searchParams, pathname } = $page.url
		
		const isBrand = $brandsStore.find(({ url }) => url === val)
		const isType = $typesStore.find(({ url }) => url === val)
		
		if (isBrand || isType) {
			if (!$page.params.slug) {
				let key = isBrand ? "brands" : "types"
				const reg = new RegExp(`(,)?${val}(,)?`)
				searchParams.set(
					key,
					searchParams.get(key).replace(reg, "$1").replace(/^,+|,+$/g, '')
				)
			} else {
				let str = searchParams.toString()
				return goto($l("cars") + (str ? "?" + str : ""))
			}
		} else {
			searchParams.delete("price_min")
			searchParams.delete("price_max")
		}

		let str = searchParams.toString()
		
		goto(pathname + (str ? "?" + str : ""), { noScroll: true, invalidateAll: true })
	}

	$: isCustomOrder = !!$page.url.searchParams.get("popular")
	const changeOrder = () => {
		const { searchParams, pathname } = $page.url
		const order = searchParams.get("popular")

		if (order)
			searchParams.delete("popular")
		else
			searchParams.append("popular", "ASC")

		let str = searchParams.toString()
		goto(pathname + (str ? "?" + str : ""), { noScroll: true, invalidateAll: true })
	}

	onMount(setTags)
	afterUpdate(setTags)
</script>

<template lang="pug">
	.top.is-flex.is-align-items-center.is-justify-content-flex-start( class:dark='{!$isLight}' )
		.clear
			Button( type="tab" on:click!='{() => active.set(!$active)}' )
				|{$t("buttons.filter")}
				span.icon( slot="icon-right" )
					+if('!$active'): SVG( folder="icons" name="widgets" )
					+if('$active'): SVG( folder="icons" name="xmark" )
		+if('$page.data.cars && !$isPhone && !$isTablet')
			.total: p {$t("default.selected", { num: $page.data.cars?.length })}
		+if('!$isPhone && !$isTablet')
			.tags.is-flex-grow-1.is-flex.is-align-items-center.is-justify-content-flex-start.is-flex-wrap-wrap
				+if('hasFilter')
					Tag( style="danger" noIcon!='{true}' on:click!='{clearFilter}' ) {$t("buttons.clear_all")}
				+each('$tags as tag')
					+if('tag')
						Tag( on:click!='{() => removeValue(tag.url)}' )
							+if('!tag.i18n')
								|{tag.name}
							+if('tag.i18n')
								|{$t(tag.name, { url: tag.url })}
		//- .sort
			Button( type="tab" on:click!='{changeOrder}' )
				|{$t("buttons.popular")}
				span.icon( slot="icon-right" )
					+if('isCustomOrder')
						SVG( folder="icons" name="triangle-up" )
					+if('!isCustomOrder')
						SVG( folder="icons" name="triangle-down" )
</template>

<style lang="scss">
	.top {
		width: 100%;
		margin-bottom: 2rem;
		padding: 1rem 0;
		background: $white;
		border-bottom: 1px solid $gray-dark;
		position: sticky;
		top: 0;
		z-index: 3;
		transition: 
			background .2s ease-in-out,
			border-color .2s ease-in-out;
		&.dark {
			background: #1E1E1E;
			border-color: #434343;
		}
	}

	.total {
		font-size: .875rem;
		font-weight: 300;
		color: $gray-text;
		margin-left: 1.5rem;
	}

	.tags {
		margin-left: 1rem;
		margin-right: .5rem;
		margin-bottom: -.5rem;
		:global(.tag) {
			margin-right: .5rem;
			margin-bottom: .5rem;
		}
	}

	.sort {
		margin-left: auto;
	}
</style>